﻿using System.Collections.ObjectModel;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;
using Telerik.Windows.Controls;
using Telerik.Windows.DragDrop;

namespace DragDropManager_WPF_574181
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();


            //radChart.ItemsSource = new ObservableCollection<object>();

            DragDropManager.AddDragInitializeHandler(radTreeView, OnDragInitialize);
            DragDropManager.AddDragInitializeHandler(radChart, OnDragInitialize);

            DragDropManager.AddGiveFeedbackHandler(radTreeView, OnGiveFeedback);
            DragDropManager.AddGiveFeedbackHandler(radChart, OnGiveFeedback);

            DragDropManager.AddDragDropCompletedHandler(radTreeView, OnDragCompleted);
            DragDropManager.AddDragDropCompletedHandler(radChart, OnDragCompleted);

            DragDropManager.AddDropHandler(radTreeView, OnDrop);
            DragDropManager.AddDropHandler(radChart, OnDrop);

            DragDropManager.AddDragEnterHandler(radChart, OnDragEnter);
        }

        //DragInitialize is replacing the old DragQuery. It is fired when a Drag is starting
        private void OnDragInitialize(object sender, DragInitializeEventArgs args)
        {

            args.AllowedEffects = DragDropEffects.All;
            var payload = DragDropPayloadManager.GeneratePayload(null);
            payload.SetData(typeof(RadTreeViewItem), ((FrameworkElement)args.OriginalSource).DataContext);
            args.Data = payload;

            args.DragVisual = new ContentControl
            {
                Content = args.Data,
                // ContentTemplate = LayoutRoot.Resources["ApplicationTemplate"] as DataTemplate
            };

        }

        private void OnGiveFeedback(object sender, Telerik.Windows.DragDrop.GiveFeedbackEventArgs args)
        {
            args.SetCursor(Cursors.Arrow);
            args.Handled = true;
        }

        //DropInfo event is replaced by Drop event. You can get here ONLY when the status is DropCompleted!
        private void OnDragEnter(object sender, Telerik.Windows.DragDrop.DragEventArgs args)
        {
            args.Effects = DragDropEffects.Move;
            args.Handled = true;
        }

        //DropInfo event is replaced by Drop event. You can get here ONLY when the status is DropCompleted!
        private void OnDrop(object sender, Telerik.Windows.DragDrop.DragEventArgs args)
        {
            args.Handled = true;
        }


        //DragInfoHandler is replaced by DragCompleted event - the status here is DropComplete!
        public void OnDragCompleted(object sender, Telerik.Windows.DragDrop.DragDropCompletedEventArgs args)
        {

        }
    }
}
